----------------------------------------------------------------------------------
--                   SCRAP POOL'S SAMPLE CONSTRUCTOR SCRIPT                     --
-- Here I outline a few useful scripting application of the Bzone Lua functions!--
-- (anything to the right of slashes is not actually script, its commentary,    --
--  and does not actually get "read")                                           --
----------------------------------------------------------------------------------

----------------------------------------------------------------------------------
-- Here the Variables I will use are Initialized
--

----------------------------------------------------------------------------------
-- Booleans
-- goala-d are typically mission objectives, which I use to keep track of if the
-- player has completed a goal in the mission
local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false

--Construction bools. These tell the script when its ok to tell a constructor to 
--drop off at a location. (After ordering a build) p = power, g = gun tower,
--s = silo, b = barracks, h = hangar, a = supply (ammo), c = comm tower,
--q = hq, f = cafeteria, l = launchpad, d = shield, etc.
local isbuilding=false
local isbuilding2=false
local isbuilding3=false
local p1dropoff=false
local p2dropoff=false
local p3dropoff=false
local p4dropoff=false
local g1dropoff=false
local g2dropoff=false
local g3dropoff=false
local g4dropoff=false
local g5dropoff=false
local g6dropoff=false
local g3dropoff=false
local g4dropoff=false
local s1dropoff=false
local s2dropoff=false
local s3dropoff=false
local b1dropoff=false
local b2dropoff=false
local h1dropoff=false
local a1dropoff=false
local c1dropoff=false
local droppingoff=false
local droppingoff2=false
local droppingoff3=false

----------------------------------------------------------------------------------
-- Floats
-- These are "numerical" variables, I use these in timers.

--Wave Spawn Timer Vars
local wave_period=200.0
local wave_timer=0.0
--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0

local topoff_period=10.0
local topoff_timer=0.0
--local cam_time=0.0
--local NextSecond=99999.0
local audmsg=0

----------------------------------------------------------------------------------
-- Handles
-- These variables keep track of specific objects in the map, here they are all
-- initialized to nil.

--Critical vars- The enemy production facilities and the player here.
local ccarecy=nil
local ccafact=nil
local player=nil

--Constructor vars- These will be used to keep track of the constructors that will be
--used and the buildings they will build. Each building in the constructors "plan"
--must have it's own variable. Each building you intend to build also must have
--a place to be built according to a point(1 pointed path) that you add to your
--map. For path naming, I use the convention build_varname# to distinguish between
--the point at which I want to build the building and the variable name for the buidling
--while scripting. The points you make should be on buildable terrain.
local const1=nil --will be labeled by AddObject according to odf
local const2=nil
local const3=nil
local spow1=nil --will be built at path(point) "build_spow1", which must be placed at buildable location on the map
local spow2=nil
local spow3=nil
local spow4=nil
local gtow1=nil
local gtow2=nil
local gtow3=nil
local gtow4=nil
local gtow5=nil
local gtow6=nil
local silo1=nil
local silo2=nil
local silo3=nil
local barr1=nil
local barr2=nil
local hang=nil
local supp=nil
local commtow=nil




function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,isbuilding,isbuilding2,isbuilding3,p1dropoff,p2dropoff,p3dropoff,p4dropoff,g1dropoff,g2dropoff,
		g3dropoff,g4dropoff,g5dropoff,g6dropoff,s1dropoff,s2dropoff,s3dropoff,b1dropoff,b2dropoff,h1dropoff,a1dropoff,c1dropoff,droppingoff,droppingoff2,droppingoff3,
		-- floats
		wave_period,wave_timer,resupply_period,resupply_timer,topoff_period,topoff_timer,
		-- handles
        ccarecy,ccafact,player,const1,const2,const3,spow1,spow2,spow3,spow4,gtow1,gtow2,gtow3,gtow4,gtow5,gtow6,silo1,silo2,silo3,barr1,barr2,barr3,hang,supp,commtow,
		-- ints
		audmsg
end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,isbuilding,isbuilding2,isbuilding3,p1dropoff,p2dropoff,p3dropoff,p4dropoff,g1dropoff,g2dropoff,
		g3dropoff,g4dropoff,g5dropoff,g6dropoff,s1dropoff,s2dropoff,s3dropoff,b1dropoff,b2dropoff,h1dropoff,a1dropoff,c1dropoff,droppingoff,droppingoff2,droppingoff3,
		-- floats
		wave_period,wave_timer,resupply_period,resupply_timer,topoff_period,topoff_timer,
		-- handles
        ccarecy,ccafact,player,const1,const2,const3,spow1,spow2,spow3,spow4,gtow1,gtow2,gtow3,gtow4,gtow5,gtow6,silo1,silo2,silo3,barr1,barr2,barr3,hang,supp,commtow,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- This sample script outlines a way to script an AI constructor(s) to build a 
-- base or set of buildings at specific points on a map in a specific order
-- when scrap is available and replace those buildings when destroyed by the
-- player or another AI.
-- Constructors require two orders to build a building: Build and Dropoff;
-- one to know what to build and another to know where to build it.
-- As of 1.5.2.9, Battlezone crashes when a constructor recieves a build and
-- dropoff command at the same time (same frame), so a little trickery is required to 
-- get the Constructor to hear the dropoff command AFTER the build command
-- even though both the dropoff scripts and build scripts live in function Update(),
-- which runs every in-game frame. Additionally, the constructor needs to 
-- know when to not listen to function Update() when it is building and on
-- its way to build, or it will recieve successive build or dropoff commands
-- every frame that will cause it to stutter and not build things, let alone 
-- repeatably in the right order. This requires two workaround boolean vars
-- each time a building is built.
-- Var purposes:
--
-- const1 is the first constructor built, const2 the second etc.
-- these are labeled as they are built into the world by function AddObject(h)
--
-- isbuilding,isbuilding2,isbuilding3 are booleans which are turned true
-- when the constructor recieves a dropoff command, so that it will sit 
-- still through the full length of the construction and not abort due to 
-- further instructions during the construction process. These are turned false
-- again when function AddObject(h) picks up and gives a handle Var to the building
-- that was being built.
--
-- p1dropoff,p2dropoff, etc, are booleans, similar in function to isbuilding,
-- but these are to get around the limitations of function Update(). Each building 
-- to be build in the plan has one of these Vars, and they are turned true by the Build
-- Script Component (which comes below the Dropoff script in function Update()),
-- so that the next time function Update() runs (in the next frame), the Dropoff
-- script will get the go-ahead to dropoff the building to which **dropoff is related,
-- thus overcoming the simultaneous build-dropoff crash. It is turned false again
-- upon the running of the related Dropoff script component.
--
-- spow1,gtow2, etc, are the Vars which contain the handles of each building that
-- exists in the game/is built by the plan. The build (and dropoff) scripts check 
-- to see if the handle correspoding to the next item in the build order is alive
-- before proceeding. If it isn't, it will get built next. 
--
-- The paths to which the Dropoff component refer are named acording to the scheme:
-- build_handlevarhere, build_spow1 for example. They must actually be placed as 
-- one-point paths in the map at the location each building is to be built.
-- The constructor does not abide terrain limitations or blockages when considering these dropoff
-- points, and this is one of the advantages of utilizing this script. (Additionally,
-- direct control over all building placements ensures power to all buildings if the 
-- paths are placed properly!
--
-- In order to change the order in which buildings are built, one must simply change 
-- the order of elseif statements in the Build Script Component.
--
--
-- Naturally, building handle vars, building dropoff vars, and anything else can be 
-- adapted to use any building anywhere by any constructor in any order. This script
-- can be adapted for any faction simply by substituting out ODF names, as well.
-- It could even be made to manage 2 different AIs or plans simulatnously, given
-- enough duplication.
-- 


function AddObject(h)
--------------------------------------------------------------------------------
-- Constructor Labeling
-- Similarly to the APCs, the constructor must be kept track of when it is built.
    if GetTeamNum(h) == 2 and IsOdf(h, "svcnst") and not IsValid(const1) then
        const1 = h
    end

--------------------------------------------------------------------------------   
-- Building Tracker-Labeler Statements
-- These statements label buildings as they are built in the game (function AddObject())
-- according to the handle vars outlined above. This allows the constructor to ask
-- if a building already exists and if it should try to build it or not. When a 
-- building is built, it is labeled according to this scheme so that the constructor 
-- can know whether it exists and should try to be built.
--
-- The GetDistance check is very important to preventing the mislabeling of buildings
-- as they enter the world. This prevents the building stacking bug by making sure that
-- the building that just came into the world (the constructor that built it) is closest
-- to the intended building site, and this keeps the lables of the same odf (gtow2,gtow6,
-- gtow5) in the correct spacial order. If they become mislabeled for thier spot, ie., a
-- gun tower is labeled gtow2 AT "build_gtow3" because gtow2 was killed druing construction,
-- the constructor will still look to build gtow3 at "build_gtow3" not knowing that the 
-- gun tower that was supposed to be labeled gtow3 was instead labeled gtow2 at that spot
-- because of the previous gtow2's destruction during construction. This causes building
-- stacking, when the constructor goes to build gtow3 at "build_gtow3" because gtow3
-- doest exist by the labeling scheme and gtow2 already exists there.
-- THUS, the distance check makes sure that the building that it is labeling is not simply 
-- the next number in line, but the one that is the relative closest to the correct building
-- path. 
-- THE IMPLICATIONS: implications of this are that building paths of the same ODF (two gun
-- tower locations, for instance) must be at least 50-60 meters apart so that the constructor
-- has to physically move in order to build one building after another. If the constructor doesn't
-- have to move to build the two same-odf buildings in a row, it will confuse the two labels and
-- stacking may ensue. THIS IS THE ONLY stipulation with this construction script!
-- PLACE IDENTICAL BUILDINGS AT LEAST 50-60 METERS APART! :)
--

--S Power
    if GetTeamNum(h) == 2 and IsOdf(h,"sbspow") and GetDistance(const1,"build_spow1")<=30.0 and not IsAlive(spow1) then
        spow1 = h
        isbuilding = false
        p1dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"sbspow") and GetDistance(const1,"build_spow2")<=30.0 and not IsAlive(spow2) then
        spow2 = h
        isbuilding = false
        p2dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"sbspow") and GetDistance(const1,"build_spow3")<=30.0 and not IsAlive(spow3) then
        spow3 = h
        isbuilding = false
        p3dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"sbspow") and GetDistance(const1,"build_spow4")<=30.0 and not IsAlive(spow4) then
        spow4 = h
        isbuilding = false
        p4dropoff = false
        droppingoff = false
    end
    
--Gun Tower
    if GetTeamNum(h) == 2 and IsOdf(h,"sbtowe") and GetDistance(const1,"build_gtow1")<=30.0 and not IsAlive(gtow1) then
        gtow1 = h
        isbuilding = false
        g1dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"sbtowe") and GetDistance(const1,"build_gtow2")<=30.0 and not IsAlive(gtow2) then
        gtow2 = h
        isbuilding = false
        g2dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"sbtowe") and GetDistance(const1,"build_gtow3")<=30.0 and not IsAlive(gtow3) then
        gtow3 = h
        isbuilding = false
        g3dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"sbtowe") and GetDistance(const1,"build_gtow4")<=30.0 and not IsAlive(gtow4) then
        gtow4 = h
        isbuilding = false
        g4dropoff = false
        droppingoff = false
    end

    
--Barracks
    if GetTeamNum(h) == 2 and IsOdf(h,"sbbarr") and GetDistance(const1,"build_barr1")<=30.0 and not IsAlive(barr1) then
        barr1 = h
        isbuilding = false
        b1dropoff = false
        droppingoff = false
        
    elseif GetTeamNum(h) == 2 and IsOdf(h,"sbbarr") and GetDistance(const1,"build_barr2")<=30.0 and not IsAlive(barr2) then
        barr2 = h
        isbuilding = false
        b2dropoff = false
        droppingoff = false
    end
    
--Hangar
    if GetTeamNum(h) == 2 and IsOdf(h,"sbhang") and not IsAlive(hang) then
        hang = h
        isbuilding = false
        h1dropoff = false
        droppingoff = false
    end
      
--Supply
    if GetTeamNum(h) == 2 and IsOdf(h,"sbsupp") and not IsAlive(supp) then
        supp = h
        isbuilding = false
        a1dropoff = false
        droppingoff = false
    end 
    
--Comm Tower
    if GetTeamNum(h) == 2 and IsOdf(h,"sbcomm") and not IsAlive(commtow) then
        commtow = h
        isbuilding = false
        c1dropoff = false
        droppingoff = false
    end 
-------       
end                   




--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

function Update ()
--------------------------------------------------------------------------------
-- Strategic AI Initialization
-- This stuff sets alliances and retrives the needed .aip files to run your AI.  
    --From Goomba's "template" not sure if it works correctly
    --Ally(3, 4) --This allies team 3 and 4, use this to ally two AI teams.
    SetAIP("craters.aip", 2) 
    --SetAIP("mpi1sov.aip", 4) --This sets the AIP file for team 4.
    --SetPilot (4, 20) --This gives team 4 20 pilots.
    --SetScrap (4, 50) --This gives team 3 50 scrap.
    
    ccarecy = GetHandle("svrecy11_recycler")
    

--------------------------------------------------------------------------------	  
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 20) 
        AddScrap (2, 140)
    end
    if topoff_timer<topoff_period then
        topoff_timer = topoff_timer + 0.0167
        else
        topoff_timer = 0.0
        if (GetScrap(2) < 20) then AddScrap(2, 1) end
        if (GetPilot(2) < 5) then AddPilot(2, 1) end
    end
    
--------------------------------------------------------------------------------    
-- Construction Orders
-- These depend on if a constructor exits, and if the team has enough scrap to do these
-- constructions. The descension of subsequent elseif statements dictates the order of-priority of construction
-- Less embedded construction orders will happen first, more embedded last.


--isbuilding Resets
--These reset the isbuilding bool if a constructor is killed during construction.
--Also must reset dropoff bools
    if not IsAlive(const1) and isbuilding then
        isbuilding = false
        droppingoff = false
        p1dropoff=false
        p2dropoff=false
        p3dropoff=false
        p4dropoff=false
        g1dropoff=false
        g2dropoff=false
        g3dropoff=false
        g4dropoff=false
        b1dropoff=false
        b2dropoff=false
        h1dropoff=false
        a1dropoff=false
        c1dropoff=false
    end
    if not IsAlive(const2) and isbuilding2 then
        isbuilding2 = false
        droppingoff2 = false
        s1dropoff=false
        s2dropoff=false
        s3dropoff=false
    end
    if not IsAlive(const3) and isbuilding3 then
        isbuilding3 = false
        droppingoff3 = false
    end
        

--Dopoff Script Component
    --Powers--
    if GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow1) and p1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow1",1)
         p1dropoff = false
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow2) and p2dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow2",1)
         p2dropoff = false
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow3) and p3dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow3",1)
         p3dropoff = false
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow4) and p4dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow4",1)
         p4dropoff = false
    --Gun Towers--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow1) and g1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow1",1)
         g1dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow2) and g2dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow2",1)
         g2dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow3) and g3dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow3",1)
         g3dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow4) and g4dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow4",1)
         g4dropoff = false
    --Barracks--
    elseif GetScrap(2)>8 and IsAlive(const1) and not IsAlive(barr1) and b1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_barr1",1)
         b1dropoff = false
    elseif GetScrap(2)>8 and IsAlive(const1) and not IsAlive(barr2) and b2dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_barr2",1)
         b2dropoff = false
    --Hangar--
    elseif GetScrap(2)>12 and IsAlive(const1) and not IsAlive(hang) and h1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_hang",1)
         h1dropoff = false
    --Supply--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(supp) and a1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_supp",1)
         a1dropoff = false
    --Comm Tower--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(commtow) and c1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_commtow",1)
         c1dropoff = false                           
    end

--Build Script Component
    --Power 1--
    if GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow1) and not droppingoff and not p1dropoff and not isbuilding then
        Build(const1,"sbspow",0)
        p1dropoff = true
        droppingoff = true
        
    --Gun Tower 1--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow1) and not droppingoff and not g1dropoff and not isbuilding then
        Build(const1,"sbtowe",0)
        g1dropoff = true
        droppingoff = true
        
    --Power 2--
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow2) and not droppingoff and not p2dropoff and not isbuilding then
        Build(const1,"sbspow",0)
        p2dropoff = true
        droppingoff = true
        
    --Gun Tower 2--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow2) and not droppingoff and not g2dropoff and not isbuilding then
        Build(const1,"sbtowe",0)
        g2dropoff = true
        droppingoff = true
           
    --Power 3--
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow3) and not droppingoff and not p3dropoff and not isbuilding then
        Build(const1,"sbspow",0)
        p3dropoff = true
        droppingoff = true
        
    --Gun Tower 3--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow3) and not droppingoff and not g3dropoff and not isbuilding then
        Build(const1,"sbtowe",0)
        g3dropoff = true
        droppingoff = true
        
    --Power 4--
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow4) and not droppingoff and not p4dropoff and not isbuilding then
        Build(const1,"sbspow",0)
        p4dropoff = true
        droppingoff = true  
              
    --Gun Tower 4--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow4) and not droppingoff and not g4dropoff and not isbuilding then
        Build(const1,"sbtowe",0)
        g4dropoff = true
        droppingoff = true
        
    --Barracks 1--
    elseif GetScrap(2)>8 and IsAlive(const1) and not IsAlive(barr1) and not droppingoff and not b1dropoff and not isbuilding then
        Build(const1,"sbbarr",0)
        b1dropoff = true
        droppingoff = true
                
    --Barracks 2--
    elseif GetScrap(2)>8 and IsAlive(const1) and not IsAlive(barr2) and not droppingoff and not b2dropoff and not isbuilding then
        Build(const1,"sbbarr",0)
        b2dropoff = true
        droppingoff = true
        
    --Hangar--
    elseif GetScrap(2)>12 and IsAlive(const1) and not IsAlive(hang) and not droppingoff and not h1dropoff and not isbuilding then
        Build(const1,"sbhang",0)
        h1dropoff = true
        droppingoff = true                       
        
    --Supply--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(supp) and not droppingoff and not a1dropoff and not isbuilding then
        Build(const1,"sbsupp",0)
        a1dropoff = true
        droppingoff = true
        
    --Comm Tower--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(commtow) and not droppingoff and not c1dropoff and not isbuilding then
        Build(const1,"sbcomm",0)
        c1dropoff = true
        droppingoff = true
    end
    
--------------------------------------------------------------------------------    
-- Mission Victory and Failure Statements
-- These will succeed or fail the mission upon the completetion of the final 
-- audio message and display the debriefing message specified.
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"cratersw.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"cratersf.des")
    end
end


