----------------------------------------------------------------------------------
--                   SCRAP POOL'S SAMPLE CONSTRUCTOR SCRIPT                     --
-- Here I outline a few useful scripting application of the Bzone Lua functions!--
-- (anything to the right of slashes is not actually script, its commentary,    --
--  and does not actually get "read")                                           --
----------------------------------------------------------------------------------

----------------------------------------------------------------------------------
-- Here the Variables I will use are Initialized
--

----------------------------------------------------------------------------------
-- Booleans
-- goala-d are typically mission objectives, which I use to keep track of if the
-- player has completed a goal in the mission
local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false

--Construction bools. These tell the script when its ok to tell a constructor to 
--drop off at a location. (After ordering a build) p = power, g = gun tower,
--s = silo, b = barracks, h = hangar, a = supply (ammo), c = comm tower,
--q = hq, f = cafeteria, l = launchpad, d = shield, etc.
local isbuilding=false
local isbuilding2=false
local isbuilding3=false
local p1dropoff=false
local p2dropoff=false
local p3dropoff=false
local p4dropoff=false
local p5dropoff=false
local g1dropoff=false
local g2dropoff=false
local g3dropoff=false
local g4dropoff=false
local g5dropoff=false
local g6dropoff=false
local g7dropoff=false
local g8dropoff=false
local s1dropoff=false
local s2dropoff=false
local s3dropoff=false
local b1dropoff=false
local b2dropoff=false
local h1dropoff=false
local a1dropoff=false
local c1dropoff=false
local droppingoff=false
local droppingoff2=false
local droppingoff3=false

----------------------------------------------------------------------------------
-- Floats
-- These are "numerical" variables, I use these in timers.

--Wave Spawn Timer Vars
local wave_period=200.0
local wave_timer=0.0
--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local topoff_period=10.0
local topoff_timer=0.0
--local cam_time=0.0
--local NextSecond=99999.0
local audmsg=0

----------------------------------------------------------------------------------
-- Handles
-- These variables keep track of specific objects in the map, here they are all
-- initialized to nil.

--Critical vars- The enemy production facilities and the player here.
local crarecy=nil
local crafact=nil
local player=nil
local apcTable = {}

--Constructor vars- These will be used to keep track of the constructors that will be
--used and the buildings they will build. Each building in the constructors "plan"
--must have it's own variable. Each building you intend to build also must have
--a place to be built according to a point(1 pointed path) that you add to your
--map. For path naming, I use the convention build_varname# to distinguish between
--the point at which I want to build the building and the variable name for the buidling
--while scripting. The points you make should be on buildable terrain.
local const1=nil --will be labeled by AddObject according to odf
local const2=nil
local const3=nil
local spow1=nil --will be built at path(point) "build_spow1", which must be placed at buildable location on the map
local spow2=nil
local spow3=nil
local spow4=nil
local spow5=nil
local gtow1=nil
local gtow2=nil
local gtow3=nil
local gtow4=nil
local gtow5=nil
local gtow6=nil
local gtow7=nil
local silo1=nil
local silo2=nil
local silo3=nil
local barr1=nil
local barr2=nil
local hang=nil
local supp=nil
local commtow=nil




function Save()
	return 
		-- bools
		mission_won,mission_lost,isbuilding,isbuilding2,p1dropoff,p2dropoff,p3dropoff,p4dropoff,p5dropoff,g1dropoff,g2dropoff,
		g3dropoff,g4dropoff,g5dropoff,g6dropoff,g7dropoff,s1dropoff,s2dropoff,s3dropoff,b1dropoff,b2dropoff,h1dropoff,a1dropoff,c1dropoff,droppingoff,droppingoff2,droppingoff3,
		-- floats
		wave_period,wave_timer,resupply_period,resupply_timer,topoff_period,topoff_timer,
		-- handles
        crarecy,crafact,player,const1,const2,spow1,spow2,spow3,spow4,spow5,gtow1,gtow2,gtow3,gtow4,gtow5,gtow6,gtow7,silo1,silo2,silo3,barr1,barr2,barr3,hang,supp,commtow,--[[apcTable,]]
		-- ints
		audmsg
end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,isbuilding,isbuilding2,p1dropoff,p2dropoff,p3dropoff,p4dropoff,p5dropoff,g1dropoff,g2dropoff,
		g3dropoff,g4dropoff,g5dropoff,g6dropoff,g7dropoff,s1dropoff,s2dropoff,s3dropoff,b1dropoff,b2dropoff,h1dropoff,a1dropoff,c1dropoff,droppingoff,droppingoff2,droppingoff3,
		-- floats
		wave_period,wave_timer,resupply_period,resupply_timer,topoff_period,topoff_timer,
		-- handles
        crarecy,crafact,player,const1,const2,spow1,spow2,spow3,spow4,spow5,gtow1,gtow2,gtow3,gtow4,gtow5,gtow6,gtow7,silo1,silo2,silo3,barr1,barr2,barr3,hang,supp,commtow,--[[apcTable,]]
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- This sample script outlines a way to script an AI constructor(s) to build a 
-- base or set of buildings at specific points on a map in a specific order
-- when scrap is available and replace those buildings when destroyed by the
-- player or another AI.
-- Constructors require two orders to build a building: Build and Dropoff;
-- one to know what to build and another to know where to build it.
-- As of 1.5.2.9, Battlezone crashes when a constructor recieves a build and
-- dropoff command at the same time (same frame), so a little trickery is required to 
-- get the Constructor to hear the dropoff command AFTER the build command
-- even though both the dropoff scripts and build scripts live in function Update(),
-- which runs every in-game frame. Additionally, the constructor needs to 
-- know when to not listen to function Update() when it is building and on
-- its way to build, or it will recieve successive build or dropoff commands
-- every frame that will cause it to stutter and not build things, let alone 
-- repeatably in the right order. This requires two workaround boolean vars
-- each time a building is built.
-- Var purposes:
--
-- const1 is the first constructor built, const2 the second etc.
-- these are labeled as they are built into the world by function AddObject(h)
--
-- isbuilding,isbuilding2,isbuilding3 are booleans which are turned true
-- when the constructor recieves a dropoff command, so that it will sit 
-- still through the full length of the construction and not abort due to 
-- further instructions during the construction process. These are turned false
-- again when function AddObject(h) picks up and gives a handle Var to the building
-- that was being built.
--
-- p1dropoff,p2dropoff, etc, are booleans, similar in function to isbuilding,
-- but these are to get around the limitations of function Update(). Each building 
-- to be build in the plan has one of these Vars, and they are turned true by the Build
-- Script Component (which comes below the Dropoff script in function Update()),
-- so that the next time function Update() runs (in the next frame), the Dropoff
-- script will get the go-ahead to dropoff the building to which **dropoff is related,
-- thus overcoming the simultaneous build-dropoff crash. It is turned false again
-- upon the running of the related Dropoff script component.
--
-- spow1,gtow2, etc, are the Vars which contain the handles of each building that
-- exists in the game/is built by the plan. The build (and dropoff) scripts check 
-- to see if the handle correspoding to the next item in the build order is alive
-- before proceeding. If it isn't, it will get built next. 
--
-- The paths to which the Dropoff component refer are named acording to the scheme:
-- build_handlevarhere, build_spow1 for example. They must actually be placed as 
-- one-point paths in the map at the location each building is to be built.
-- The constructor does not abide terrain limitations or blockages when considering these dropoff
-- points, and this is one of the advantages of utilizing this script. (Additionally,
-- direct control over all building placements ensures power to all buildings if the 
-- paths are placed properly!
--
-- In order to change the order in which buildings are built, one must simply change 
-- the order of elseif statements in the Build Script Component.
--
--
-- Naturally, building handle vars, building dropoff vars, and anything else can be 
-- adapted to use any building anywhere by any constructor in any order. This script
-- can be adapted for any faction simply by substituting out ODF names, as well.
-- It could even be made to manage 2 different AIs or plans simulatnously, given
-- enough duplication.
-- 


function AddObject(h)
--------------------------------------------------------------------------------
-- Constructor Labeling
-- Similarly to the APCs, the constructor must be kept track of when it is built.
    if GetTeamNum(h) == 2 and IsOdf(h, "cvcnst") and IsValid(const1) and not IsValid(const2) then
        const2 = h
    end
    if GetTeamNum(h) == 2 and IsOdf(h, "cvcnst") and not IsValid(const1) then
        const1 = h
    end

--------------------------------------------------------------------------------
-- APC LABELING  
    if IsOdf(h,"cvapc") then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, h)
    end 

--------------------------------------------------------------------------------   
-- Building Tracker-Labeler Statements
-- These statements label buildings as they are built in the game (function AddObject())
-- according to the handle vars outlined above. This allows the constructor to ask
-- if a building already exists and if it should try to build it or not. When a 
-- building is built, it is labeled according to this scheme so that the constructor 
-- can know whether it exists and should try to be built.
--
-- The GetDistance check is very important to preventing the mislabeling of buildings
-- as they enter the world. This prevents the building stacking bug by making sure that
-- the building that just came into the world (the constructor that built it) is closest
-- to the intended building site, and this keeps the lables of the same odf (gtow2,gtow6,
-- gtow5) in the correct spacial order. If they become mislabeled for thier spot, ie., a
-- gun tower is labeled gtow2 AT "build_gtow3" because gtow2 was killed druing construction,
-- the constructor will still look to build gtow3 at "build_gtow3" not knowing that the 
-- gun tower that was supposed to be labeled gtow3 was instead labeled gtow2 at that spot
-- because of the previous gtow2's destruction during construction. This causes building
-- stacking, when the constructor goes to build gtow3 at "build_gtow3" because gtow3
-- doest exist by the labeling scheme and gtow2 already exists there.
-- THUS, the distance check makes sure that the building that it is labeling is not simply 
-- the next number in line, but the one that is the relative closest to the correct building
-- path. 
-- THE IMPLICATIONS: implications of this are that building paths of the same ODF (two gun
-- tower locations, for instance) must be at least 50-60 meters apart so that the constructor
-- has to physically move in order to build one building after another. If the constructor doesn't
-- have to move to build the two same-odf buildings in a row, it will confuse the two labels and
-- stacking may ensue. THIS IS THE ONLY stipulation with this construction script!
-- PLACE IDENTICAL BUILDINGS AT LEAST 50-60 METERS APART! :)
--
-- Note that it is INADVISABLE TO have the distance check for buildings which you plan to only
-- have one of or buildings for which the constructor sits greater than 30.0m away from while constructing
-- (large buildings). The check distance can of course be set to greater than 30.0 for these large
-- buildings and it will work, but mostly, large buildings are only "NUMBER_TO_HAVE = 1", so it is
-- better not to have this requirement, as it is impossible to confuse labels with a single building
-- of one odf type in the labeling order because of the IsOdf check.
-- (DON'T ADD GedDistance()<=# for hangars, supplies, comm towers, or anything else you plan to have
-- only one of! :))
--S Power
    if GetTeamNum(h) == 2 and IsOdf(h,"cbspow") and GetDistance(const1,"build_spow1")<=30.0 and not IsAlive(spow1) then
        spow1 = h
        isbuilding = false
        p1dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cbspow") and GetDistance(const1,"build_spow2")<=30.0 and not IsAlive(spow2) then
        spow2 = h
        isbuilding = false
        p2dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cbspow") and GetDistance(const1,"build_spow3")<=30.0 and not IsAlive(spow3) then
        spow3 = h
        isbuilding = false
        p3dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cbspow") and GetDistance(const1,"build_spow4")<=30.0 and not IsAlive(spow4) then
        spow4 = h
        isbuilding = false
        p4dropoff = false
        droppingoff = false
    end
    
--Gun Tower
    if GetTeamNum(h) == 2 and IsOdf(h,"cbtowe") and GetDistance(const1,"build_gtow1")<=30.0 and not IsAlive(gtow1) then
        gtow1 = h
        isbuilding = false
        g1dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cbtowe") and GetDistance(const1,"build_gtow2")<=30.0 and not IsAlive(gtow2) then
        gtow2 = h
        isbuilding = false
        g2dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cblasr") and GetDistance(const1,"build_gtow3")<=30.0 and not IsAlive(gtow3) then
        gtow3 = h
        isbuilding = false
        g3dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cblasr") and GetDistance(const1,"build_gtow4")<=30.0 and not IsAlive(gtow4) then
        gtow4 = h
        isbuilding = false
        g4dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cblasr") and GetDistance(const1,"build_gtow5")<=30.0 and not IsAlive(gtow5) then
        gtow5 = h
        isbuilding = false
        g5dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cblasr") and GetDistance(const1,"build_gtow6")<=30.0 and not IsAlive(gtow6) then
        gtow6 = h
        isbuilding = false
        g6dropoff = false
        droppingoff = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cblasr") and GetDistance(const1,"build_gtow7")<=30.0 and not IsAlive(gtow7) then
        gtow7 = h
        isbuilding = false
        g7dropoff = false
        droppingoff = false
    end

--Silos
    if GetTeamNum(h) == 2 and IsOdf(h,"cbsilo") and GetDistance(const2,"build_silo1")<=80.0 and not IsAlive(silo1) then
        silo1 = h
        isbuilding2 = false
        s1dropoff = false
        droppingoff2 = false
    elseif GetTeamNum(h) == 2 and IsOdf(h,"cbsilo") and GetDistance(const2,"build_silo2")<=80.0 and not IsAlive(silo2) then
        silo2 = h
        isbuilding2 = false
        s2dropoff = false
        droppingoff2 = false
    end 
    
--Hangar
    if GetTeamNum(h) == 2 and IsOdf(h,"cbhang") and not IsAlive(hang) then
        hang = h
        isbuilding = false
        h1dropoff = false
        droppingoff = false
    end
      
--Supply
    if GetTeamNum(h) == 2 and IsOdf(h,"cbmbld") and not IsAlive(supp) then
        supp = h
        isbuilding = false
        a1dropoff = false
        droppingoff = false
    end 
    
--Comm Tower
    if GetTeamNum(h) == 2 and IsOdf(h,"cbcomm") and not IsAlive(commtow) then
        commtow = h
        isbuilding = false
        c1dropoff = false
        droppingoff = false
    end 
-------       
end                   




--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

function Update ()
--------------------------------------------------------------------------------
-- Strategic AI Initialization
-- This stuff sets alliances and retrives the needed .aip files to run your AI.  
    --From Goomba's "template" not sure if it works correctly
    --Ally(3, 4) --This allies team 3 and 4, use this to ally two AI teams.
    SetAIP("strikebk.aip", 2) 
    --SetAIP("mpi1sov.aip", 4) --This sets the AIP file for team 4.
    --SetPilot (2, 20) 
    --SetScrap (2, 50)
    --SetPilot (4, 20) --This gives team 4 20 pilots.
    --SetScrap (4, 50) --This gives team 3 50 scrap.
    
    player = GetPlayerHandle()
    nsdfrecy = GetHandle("")
    nsdffact = GetHandle("")
    

--------------------------------------------------------------------------------	  
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 20) 
        AddScrap (2, 135)
    end
    if topoff_timer<topoff_period then
        topoff_timer = topoff_timer + 0.0167
        else
        topoff_timer = 0.0
        if (GetScrap(2) < 20) then AddScrap(2, 1) end
        if (GetPilot(2) < 5) then AddPilot(2, 1) end
    end
    
---------------------------------------------------------
--APC Attack
--       
    for i = 1, # apcTable do
          if IsAlive(apcTable[i]) and GetDistance(apcTable[i],GetNearestEnemy(apcTable[i]))<100.0 and not IsDeployed(apcTable[i]) then
                Deploy(apcTable[i])
          end
    end     
    if IsOdf(GetNearestEnemy(player),"cvapc") and not apcTable[GetNearestEnemy(player)] then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, GetNearestEnemy(player))
    end     
    
--------------------------------------------------------------------------------    
-- Construction Orders
-- These depend on if a constructor exits, and if the team has enough scrap to do these
-- constructions. The descension of subsequent elseif statements dictates the order of-priority of construction
-- Less embedded construction orders will happen first, more embedded last.


--isbuilding Resets
--These reset the isbuilding bool if a constructor is killed during construction.
--Also must reset dropoff bools
    if not IsAlive(const1) and isbuilding then
        isbuilding = false
        droppingoff = false
        p1dropoff=false
        p2dropoff=false
        p3dropoff=false
        p4dropoff=false
        g1dropoff=false
        g2dropoff=false
        g3dropoff=false
        g4dropoff=false
        g5dropoff=false
        b1dropoff=false
        b2dropoff=false
        h1dropoff=false
        a1dropoff=false
        c1dropoff=false
        p5dropoff=false
        g6dropoff=false
        g7dropoff=false
    end
    if not IsAlive(const2) and isbuilding2 then
        isbuilding2 = false
        droppingoff2 = false
        s1dropoff=false
        s2dropoff=false
        
    end
    if not IsAlive(const3) and isbuilding3 then
        isbuilding3 = false
        droppingoff3 = false
    end
    
    if IsAlive(silo1) and IsAlive(silo2) then
        if GetDistance(const2,silo1)<60.0 and GetDistance(player,const2)<100.0 then
            RemoveObject(const2)
            AddScrap(2,8.0)
        end
        if GetDistance(const2,silo2)<60.0 and GetDistance(player,const2)<100.0 then
            RemoveObject(const2)
            AddScrap(2,8.0)
        end
    end
        
----------------------------------------------------
--Dopoff Script Component
--
-- There are six checks that happen for this subroutine:
-- 1) Do we have enough scrap?
-- 2) Is the constructor that is to do the constructing alive?
-- 3) Is the building we are trying to build NOT alive?
-- 4) Did we get the order to drop this off from the Build Script Component (p1dropoff)?
-- 5) Are we currently in the dropoff order stage?
-- 6) Are we currently NOT building?
-- If all of these are true, then we say we are building and give the order to drop the building off,
-- while saying that the order to drop this off has been given.

    --Powers--
    if GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow1) and p1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow1",1)
         p1dropoff = false
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow2) and p2dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow2",1)
         p2dropoff = false
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow3) and p3dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow3",1)
         p3dropoff = false
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow4) and p4dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_spow4",1)
         p4dropoff = false  
    --Gun Towers--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow1) and g1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow1",1)
         g1dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow2) and g2dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow2",1)
         g2dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow3) and g3dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow3",1)
         g3dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow4) and g4dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow4",1)
         g4dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow5) and g5dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow5",1)
         g5dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow6) and g6dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow6",1)
         g6dropoff = false
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow7) and g7dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_gtow7",1)
         g7dropoff = false     
    --Silos--
    elseif GetScrap(2)>4 and IsAlive(const2) and not IsAlive(silo1) and s1dropoff and droppingoff2 and not isbuilding2 then
         isbuilding2 = true
         Dropoff(const2,"build_silo1",1)
         s1dropoff = false
    elseif GetScrap(2)>4 and IsAlive(const2) and not IsAlive(silo2) and s2dropoff and droppingoff2 and not isbuilding2 then
         isbuilding2 = true
         Dropoff(const2,"build_silo2",1)
         s2dropoff = false
    --Hangar--
    elseif GetScrap(2)>12 and IsAlive(const1) and not IsAlive(hang) and h1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_hang",1)
         h1dropoff = false
    --Supply--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(supp) and a1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_supp",1)
         a1dropoff = false
    --Comm Tower--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(commtow) and c1dropoff and droppingoff and not isbuilding then
         isbuilding = true
         Dropoff(const1,"build_commtow",1)
         c1dropoff = false                           
    end

----------------------------------------------------
--Build Script Component
-- 
-- This component is the enumerator of our build order and checks to
-- see if we should try to build a building in that order.
-- There are 7(8) checks in this subroutine:
-- 1) Do we have enough scrap?
-- 2) Is the constructor to do the construction alive?
-- 3) Is the thing we want to build NOT alive right now?
-- 4) Are we NOT already fulfilling an order to drop off?
-- 5) Are we NOT already fulfilling an order to drop THIS building off?
-- 6) Are we NOT currently building?
-- 7) Is there enough space around the target dropoff path? 
-- Number seven is not critical, but it "realistically" prevents buildings
-- from stacking and buildings being built on scrap, which may frustrate scavs.
-- Implement these if you are worried about the possibility of stacking.
-- If anything is blocking construction, the constructor will move on.
--
-- 8) Does the powered building(gun tower) we are trying to build have its
-- associated power?
-- Number eight is not necessary either, and requires specific planning of the
-- spaces and path placements to know which power is associated with which
-- gun tower, so that you can modify this check specifically for specific buildings.
-- It does prevent constructors from building unpowered gun towers and emulates
-- the power requirement. Again, this script is for specific building placement design.
-- (ONLY NECESSARY WHEN WE HAVE NUMBER 7)
--
-- Checks seven and eight are not necessary at all; to maintain power simply put powers
-- ahead of the buildings they power in the order. However, checks 7 and 8 are necessary for
-- each other, and add an element of variability to the constructor's patterns.

    --Power 1--
    if GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow1) and not droppingoff and not p1dropoff and not isbuilding then
        Build(const1,"cbspow",0)
        p1dropoff = true
        droppingoff = true
        
    --Gun Tower 1--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow1) and not droppingoff and not g1dropoff and not isbuilding and IsAlive(spow1) then
        Build(const1,"cbtowe",0)
        g1dropoff = true
        droppingoff = true

    --Gun Tower 2--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow2) and not droppingoff and not g2dropoff and not isbuilding and IsAlive(spow1) then
        Build(const1,"cbtowe",0)
        g2dropoff = true
        droppingoff = true
        
    --Power 2--
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow2) and not droppingoff and not p2dropoff and not isbuilding then
        Build(const1,"cbspow",0)
        p2dropoff = true
        droppingoff = true
        
    --Gun Tower 3--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow3) and not droppingoff and not g3dropoff and not isbuilding and IsAlive(spow2) then
        Build(const1,"cblasr",0)
        g3dropoff = true
        droppingoff = true 
        
    --Gun Tower 4--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow4) and not droppingoff and not g4dropoff and not isbuilding and IsAlive(spow2) then
        Build(const1,"cblasr",0)
        g4dropoff = true
        droppingoff = true  
        
    --Power 3--
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow3) and not droppingoff and not p3dropoff and not isbuilding then
        Build(const1,"cbspow",0)
        p3dropoff = true
        droppingoff = true  
        
    --Gun Tower 5--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow5) and not droppingoff and not g5dropoff and not isbuilding and IsAlive(spow3) then
        Build(const1,"cblasr",0)
        g5dropoff = true
        droppingoff = true  

    --Gun Tower 6--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow6) and not droppingoff and not g6dropoff and not isbuilding and IsAlive(spow3) then
        Build(const1,"cblasr",0)
        g6dropoff = true
        droppingoff = true
   
    --Power 4--
    elseif GetScrap(2)>4 and IsAlive(const1) and not IsAlive(spow4) and not droppingoff and not p4dropoff and not isbuilding then
        Build(const1,"cbspow",0)
        p4dropoff = true
        droppingoff = true  

    --Gun Tower 7--
    elseif GetScrap(2)>6 and IsAlive(const1) and not IsAlive(gtow7) and not droppingoff and not g6dropoff and not isbuilding and IsAlive(spow4) then
        Build(const1,"cblasr",0)
        g7dropoff = true
        droppingoff = true  

    --Supply--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(supp) and not droppingoff and not a1dropoff and not isbuilding then
        Build(const1,"cbmbld",0)
        a1dropoff = true
        droppingoff = true 
        
    --Hangar--
    elseif GetScrap(2)>8 and IsAlive(const1) and not IsAlive(hang) and not droppingoff and not h1dropoff and not isbuilding then
        Build(const1,"cbhang",0)
        h1dropoff = true
        droppingoff = true  

    --Comm Tower--
    elseif GetScrap(2)>10 and IsAlive(const1) and not IsAlive(commtow) and not droppingoff and not c1dropoff and not isbuilding then
        Build(const1,"cbcomm",0)
        c1dropoff = true
        droppingoff = true
     
    --Silo 1--
    elseif GetScrap(2)>4 and IsAlive(const2) and not IsAlive(silo1) and not droppingoff2 and not s1dropoff and not isbuilding2 then
        Build(const2,"cbsilo",0)
        s1dropoff = true
        droppingoff2 = true
                
    --Silo 2--
    elseif GetScrap(2)>4 and IsAlive(const2) and not IsAlive(silo2) and not droppingoff2 and not s2dropoff and not isbuilding2 then
        Build(const2,"cbsilo",0)
        s2dropoff = true
        droppingoff2 = true
     
    end
    
--------------------------------------------------------------------------------    
-- Mission Victory and Failure Statements
-- These will succeed or fail the mission upon the completetion of the final 
-- audio message and display the debriefing message specified.
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"strikebkw.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"strikebkf.des")
    end
end


